1 # Copyright (c) 2013, 2015, Oracle and/or its affiliates. All rights reserved.
   2 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
   3 #
   4 # This code is free software; you can redistribute it and/or modify it
   5 # under the terms of the GNU General Public License version 2 only, as
   6 # published by the Free Software Foundation.
   7 #
   8 # This code is distributed in the hope that it will be useful, but WITHOUT
   9 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  10 # FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  11 # version 2 for more details (a copy is included in the LICENSE file that
  12 # accompanied this code).
  13 #
  14 # You should have received a copy of the GNU General Public License version
  15 # 2 along with this work; if not, write to the Free Software Foundation,
  16 # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
  17 #
  18 # Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
  19 # or visit www.oracle.com if you need additional information or have any
  20 # questions.
  21 #
  22 
  23 # @test
  24 # @bug 6888954
  25 # @bug 8015884
  26 # @summary exercise HotSpot error handling code
  27 # @author John Coomes
  28 # @run shell vmerrors.sh
  29 
  30 # Repeatedly invoke java with a command-line option that causes HotSpot to
  31 # produce an error report and terminate just after initialization.  Each
  32 # invocation is identified by a small integer, <n>, which provokes a different
  33 # error (assertion failure, guarantee failure, fatal error, etc.).  The output
  34 # from stdout/stderr is written to <n>.out and the hs_err_pidXXX.log file is
  35 # renamed to <n>.log.
  36 #
  37 # The automated checking done by this script is minimal.  When updating the
  38 # fatal error handler it is more useful to run it manually or to use the -retain
  39 # option with the jtreg so that test directories are not removed automatically.
  40 # To run stand-alone:
  41 #
  42 # TESTJAVA=/java/home/dir
  43 # TESTVMOPTS=...
  44 # export TESTJAVA TESTVMOPTS
  45 # sh test/runtime/6888954/vmerrors.sh
  46 
  47 ulimit -c 0 # no core files
  48 
  49 i=1
  50 rc=0
  51 
  52 assert_re='(assert|guarantee)[(](str|num).*failed: *'
  53 # for bad_data_ptr_re:
  54 # EXCEPTION_ACCESS_VIOLATION - Win-*
  55 # SIGILL - MacOS X
  56 # SIGSEGV - Linux-*, Solaris SPARC-*, Solaris X86-*
  57 #
  58 bad_data_ptr_re='(SIGILL|SIGSEGV|EXCEPTION_ACCESS_VIOLATION).* at pc='
  59 #
  60 # for bad_func_ptr_re:
  61 # EXCEPTION_ACCESS_VIOLATION - Win-*
  62 # SIGBUS - Solaris SPARC-64
  63 # SIGSEGV - Linux-*, Solaris SPARC-32, Solaris X86-*
  64 # SIGILL - Aix
  65 #
  66 # Note: would like to use "pc=0x00*0f," in the pattern, but Solaris SPARC-*
  67 # gets its signal at a PC in test_error_handler().
  68 #
  69 bad_func_ptr_re='(SIGBUS|SIGSEGV|SIGILL|EXCEPTION_ACCESS_VIOLATION).* at pc='
  70 guarantee_re='guarantee[(](str|num).*failed: *'
  71 fatal_re='fatal error: *'
  72 tail_1='.*expected null'
  73 tail_2='.*num='
  74 
  75 for re in                                                 \
  76     "${assert_re}${tail_1}"    "${assert_re}${tail_2}"    \
  77     "${guarantee_re}${tail_1}" "${guarantee_re}${tail_2}" \
  78     "${fatal_re}${tail_1}"     "${fatal_re}${tail_2}"     \
  79     "${fatal_re}.*truncated"   "ChunkPool::allocate"      \
  80     "ShouldNotCall"            "ShouldNotReachHere"       \
  81     "Unimplemented"            "$bad_data_ptr_re"         \
  82     "$bad_func_ptr_re"
  83 
  84 do
  85     i2=$i
  86     [ $i -lt 10 ] && i2=0$i
  87 
  88     "$TESTJAVA/bin/java" $TESTVMOPTS -XX:+IgnoreUnrecognizedVMOptions \
  89         -XX:-TransmitErrorReport \
  90         -XX:ErrorHandlerTest=${i} -version > ${i2}.out 2>&1
  91 
  92     # If ErrorHandlerTest is ignored (product build), stop.
  93     #
  94     # Using the built-in variable $! to get the pid does not work reliably on
  95     # windows; use a wildcard instead.
  96     mv hs_err_pid*.log ${i2}.log || exit $rc
  97 
  98     for f in ${i2}.log ${i2}.out
  99     do
 100         egrep -- "$re" $f > $$
 101         if [ $? -ne 0 ]
 102         then
 103             echo "ErrorHandlerTest=$i failed ($f)"
 104             rc=1
 105         fi
 106     done
 107     rm -f $$
 108 
 109     i=`expr $i + 1`
 110 done
 111 
 112 exit $rc